EDIT - bug #8343

potential timezone problem in application stack
06/27/2019 07:07 PM - Andreas Kohlbecker

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.32

Severity: normal Found in Version:

Description

Ist denn genau definiert, um welche Zeitzone es sich handelt? Ich frage auch weil auf
https://www.phycobank.org/cdm_dataportal/registration/http%253A%252F %252Fphycobank.org%252F100160 z.B.

2018-06-11 22:00:00 als DateTime genannt ist. Das sieht nach einer Verschiebung durch die Zeitzone aus. Vermutlich ist eher
2018-06-12 gemeint.

Aber auch sonst wére natirlich interessant, ob Europe/Berlin oder UTC dargestellt wird, wenn man die Uhrzeit schon mit ausgibt.
2018-06-11 22:00:00

Na die Uhrzeit ist die typische Uhrzeit die du bekommst, wenn du Daten mit Zeitzone CEST eingibst und diese dann auf UTC (also 2
h rickwarts gerechnet werden). Das habe ich schon oft gesehen. Ware schon sehr groBBer Zufall, wenn jemand die Daten wirklich

auf die Sekunde um 22:00:00 eingegeben hatte. Gemeint ist aber vermutlich 2018-06-12 ohne Uhrzeit und das finde ich nicht so
schoén, dass das Datum sich da verschiebt.

Related issues:

Related to EDIT - task #8118: Update MySQL drivers Feedback
Related to EDIT - bug #10079: Fix timezone problems after upgrading jadira.us... In Progress
History

#1 - 06/27/2019 07:13 PM - Andreas Kohlbecker
- Status changed from New to Rejected

- Target version deleted (Unassigned CDM tickets)

| don't think that we are having a timezone shift problem since the date is stored in the db as 2018-06-11 22:00:00. This is at least what mysq| is
sending to the client.

Maybe this is an issue which comes from the time when the timezone data was not correctly set in for the mysq|l servers see #8118 and
MySqlFag#The-server-time-zone-value-is-unrecognized

#2 - 07/16/2019 03:16 PM - Andreas Miiller
- Status changed from Rejected to Feedback

- Target version set to Unassigned CDM tickets

| don't understand why this is rejected. The problem still exists as you can see in the above link. It might not be a dataportal issue so we may change
the category. But by closing the ticket we will forget that either the MySQL server is not correctly configured or the data is incorrect.

#3 - 07/16/2019 03:17 PM - Andreas Miiller
- Related to task #8118: Update MySQL drivers added

#4 - 07/16/2019 03:18 PM - Andreas Miiller
Andreas Kohlbecker wrote:
Maybe this is an issue which comes from the time when the timezone data was not correctly set in for the mysql servers see #8118 and

MySqlFag#The-server-time-zone-value-is-unrecognized

Can you please provide a link to the above FAQ?
#5 - 07/16/2019 04:47 PM - Andreas Kohlbecker

Andreas Miller wrote:
Andreas Kohlbecker wrote:
Maybe this is an issue which comes from the time when the timezone data was not correctly set in for the mysql servers see #8118 and
MySqlFag#The-server-time-zone-value-is-unrecognized

Can you please provide a link to the above FAQ?

here it is: MySqlFaq

#6 - 07/16/2019 05:02 PM - Andreas Kohlbecker
- Subject changed from potential timezone problem in format_datetime() to potential timezone problem in application stack
- Category changed from cdm-dataportal to cdmlib

- Assignee deleted (Andreas Kohlbecker)
Andreas Muller wrote:
| don't understand why this is rejected. The problem still exists as you can see in the above link. It might not be a dataportal issue so we may

change the category. But by closing the ticket we will forget the either the MySQL server is not correctly configured or the data is incorrect.

"MySQL converts TIMESTAMP values from the current time zone to UTC for storage, and back from UTC to the current time zone for retrieval. (This
does not occur for other types such as DATETIME." (see https://dev.mysql.com/doc/refman/5.6/en/datetime.html). So it seems as if the timezone was
set to UTC+2 (=CEST) when 2018-06-12 was stored in the db, so it was filed as 2018-06-11 22:00:00.

If the whole application stack from client to server is respecting and handling the zimezone correctly the datetime should come out as 2018-06-12.
This in deed needs more reseach. | am changing the subject to better reflect the general importance of this issue.

#7 - 10/27/2021 04:15 PM - Andreas Miiller
- Assignee set to Andreas Kohlbecker

- Target version changed from Unassigned CDM tickets to Release 5.45

Is this solved in the meanwhile? https://www.phycobank.org/cdm_dataportal/registration-search/filter?identifier=100160 now shows the correct date
(though for datetime with time 00:00:00 we should probably better remove the time during formatting)

#8 - 01/20/2022 03:59 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Miller

Andreas Muller wrote in #note-7:

Is this solved in the meanwhile? https://www.phycobank.org/cdm_dataportal/registration-search/filter ?identifier=100160 now shows the correct
date (though for datetime with time 00:00:00 we should probably better remove the time during formatting)

| am a bit confused by your last comment. In comment 6 you explained that this issue is of general importance for the whole application stack. An
topic which "in deed needs more reseach". | dont unterstand how we can interpolate from one single place in the Ul with correctly shown dates, to the
rest of the stack.

#9 - 01/21/2022 12:09 AM - Andreas Miiller

Andreas Kohlbecker wrote in #note-8:

Andreas Muller wrote in #note-7:

Is this solved in the meanwhile? https://www.phycobank.org/cdm_dataportal/registration-search/filter?identifier=100160 now shows the
correct date (though for datetime with time 00:00:00 we should probably better remove the time during formatting)

| am a bit confused by your last comment. In comment 6 you explained that this issue is of general importance for the whole application stack.
An topic which "in deed needs more reseach". | dont unterstand how we can interpolate from one single place in the Ul with correctly shown
dates, to the rest of the stack.

Comment 6 was yours not mine. However, | also do not understand why | said "{link} now shows the correct date". At least now it shows 2018-06-11
22:00:00 (again?) which seems not correct (but | didn't check the stored data).

#10 - 02/10/2022 11:22 AM - Andreas Miiller

- Assignee changed from Andreas Miiller to Andreas Kohlbecker

#11 - 02/22/2022 10:47 AM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Miller

#12 - 06/16/2022 09:14 AM - Katja Luther

Andreas Muller wrote in #note-9:

Andreas Kohlbecker wrote in #note-8:

Andreas Muller wrote in #note-7:

Is this solved in the meanwhile? https://www.phycobank.org/cdm_dataportal/registration-search/filter?identifier=100160 now shows the
correct date (though for datetime with time 00:00:00 we should probably better remove the time during formatting)

| am a bit confused by your last comment. In comment 6 you explained that this issue is of general importance for the whole application
stack. An topic which "in deed needs more reseach". | dont unterstand how we can interpolate from one single place in the Ul with correctly
shown dates, to the rest of the stack.

Comment 6 was yours not mine. However, | also do not understand why | said "{link} now shows the correct date". At least now it shows
2018-06-11 22:00:00 (again?) which seems not correct (but | didn't check the stored data).

Actually in the database there are dates like "1998-10-19 22:00:00" as well as "1998-10-19 23:00:00", both are showing as 1998-10-20 00:00:00 in
Berlin in the portal output.

The timezone of the server is

SELECT @@global.time_zone, @@session.time_zone;
| @@global.time_zone | @@session.time_zone |
| Europe/Berlin | Europe/Berlin |

4 ' s
+ + +

#13 - 06/16/2022 11:20 AM - Katja Luther

Locally | added the timezone to the out put and for http://phycobank.org/100158 the timezone was CEST and for http:/phycobank.org/100145 the
timezone was CET. Actually there should be no timezone information in DATETIME??

For the test data the timezone was CET.

#14 - 06/22/2022 02:52 PM - Andreas Miiller
- Related to bug #10079: Fix timezone problems after upgrading jadira.usertype, hibernate and/or mysql drivers added

#15 - 06/22/2022 02:58 PM - Andreas Miiller
Katja Luther wrote in #note-13:
... Actually there should be no timezone information in DATETIME??
Are we talking about MySQL DATETIME? This is somehow true, but togehter with the global timezone of the DB Server there should be a timezone
and also joda DateTime always includes a timezone information.

For the test data the timezone was CET.

CET or CEST depends on the date being in winter or summer not on the server.

#16 - 06/22/2022 03:01 PM - Andreas Miiller
- Status changed from Feedback to In Progress
- Priority changed from New to Highest

- Target version changed from Release 5.45 to Release 5.32
- % Done changed from 0 to 30

IMPORTANT:

This task got a new flavour after upgrading some libraries (hibernate, jadira-usertype, mysql-connector, json). Now at least the webservices come with
timezone information which they didn't before, see #10079. We should reevaluate this ticket here after fixing #10079.

#17 - 07/08/2022 11:05 PM - Andreas Miiller
- Status changed from In Progress to Closed

- % Done changed from 30 to 100

| think this ticket can be closed. The timezone problem is now solved with correct availability of timezone information in webservices after upgrading to

jadira-usertype 7.0.
Addtional formatting requirements for phycobank are handled in #100794#note-8
